!	test_f_smbpass.for
!
!	test/debug the f_smbpass routines
!
!	this module is NOT needed to build SAMBA
!
	implicit none
!
! subroutine fsmb_openfile(byte filename(), i*4 unum, i*4 status)
! subroutine fsmb_closefile(i*4 unum, i*4 status)
! subroutine fsmb_find_by_name(i*4 unum, i*4 name(8), i*4 data(18), i*4 status)
! subroutine fsmb_find_by_uic(i*4 unum, i*4 uic, i*4 data(18), i*4 status)
! subroutine fsmb_append_entry(i*4 unum, i*4 data(18), i*4 status)
! subroutine fsmb_modify_last_entry(i*4 unum, i*4 data(18), i*4 status)
!

	character filename*20
	integer*4 flen,unum,status,name(8),uic,data(18),i,j
	byte b1
	equivalence (b1,filename(1:1))
!
	write(6,*)'Status = 0 is success, anything else is failure'
	write(6,*)'If you rerun this test without first deleting tst.pwd'
	write(6,*)'9 of the first 10 adds will fail, since it will reuse'
	write(6,*)'the tst.pwd file.'
	write(6,*)' '
	filename= 'tst.pwd'//char(0)
!
!	open a file, this assumes that it is new!!!
!
	call fsmb_openfile(b1, 10, status)
	if(status .ne. 0)then
	  write(6,*)'oops, openfile status was ',status
	end if
!
!	add some good records to it
!
	do j = 1,10
	  do i=1,7
	     data(i)='55554444'x
	  end do
	  data(8)=50+j          !password ends here
	  data(9)=40+j          !uic
	  data(10)=70+j
	   call fsmb_append_entry(10, data, status)
	   write(6,*)'added entry ',j,' status = ',status
	end do
!
!       add some bad records to it
!
	call fsmb_append_entry(10, data, status)
	write(6,*)'readded entry 10 status = ',status
	data(8)=5
	data(9)=100
	write(6,*)'tried to add name5 again, different UIC, status = ',status
!
!	now try to retrieve some by name
!
	data(8)=55
	call fsmb_find_by_name(10, data, data, status)
	write(6,*)'retrieve name5, status = ',status
!	call showit(data)
	data(8)=54
	call fsmb_find_by_name(10, data, data, status)
	write(6,*)'retrieve name4, status = ',status
!	call showit(data)
	data(8)=0
	call fsmb_find_by_name(10, data, data, status)
	write(6,*)'retrieve name0, status = ',status
!	call showit(data)
!
!	now try to retrieve some by uic
!
	data(9)=45
	call fsmb_find_by_uic(10, data(9), data, status)
	write(6,*)'retrieve 5 by uic, status = ',status
!	call showit(data)
	data(9)=44
	call fsmb_find_by_uic(10, data(9), data, status)
	write(6,*)'retrieve 4 by uic, status = ',status
!	call showit(data)
	data(9)=0
	call fsmb_find_by_uic(10, data(9), data, status)
	write(6,*)'retrieve 0 by uic, status = ',status
!	call showit(data)
!
	write(6,*)'modify a record by valid UIC'
	data(9)=45
	call fsmb_find_by_uic(10, data(9), data, status)
	data(9)=100
	call fsmb_modify_last_entry(10, data, status)
	write(6,*)'modified record, UIC 45->100, status= ',status
	call fsmb_find_by_uic(10, 100, data, status)
	write(6,*)'retrieve record by new UIC, status= ',status


	write(6,*)'delete a record by valid UIC'
!
	data(9)=44
	call fsmb_find_by_uic(10, data(9), data, status)
	call fsmb_delete_last_entry(10, status)
	write(6,*)'delete status = ',status
!
	write(6,*)'delete a record by INvalid UIC'
	data(9)=0
	call fsmb_find_by_uic(10, data(9), data, status)
	call fsmb_delete_last_entry(10, status)
	write(6,*)'delete status = ',status

	call fsmb_closefile(10, status)
	write(6,*)'closed it, status = ',status
	stop
	end

	subroutine showit(data)
	implicit none
	integer*4 data(18),i
	write(6,1000)(data(i),i=1,8),data(9)
1000	format(' ',8z8,' uic: ',z8)
	return
	end
